/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PLUS
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != LTU
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 16
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x13 = XEXP (x3, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[3] = x14;
  if (!rx_source_operand (operands[3], E_SImode))
    return -1;
  x15 = XEXP (x4, 0);
  operands[1] = x15;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x16 = XEXP (x6, 1);
  operands[4] = x16;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x17 = XEXP (x5, 1);
  operands[5] = x17;
  if (!rx_source_operand (operands[5], E_SImode))
    return -1;
  x18 = XEXP (x9, 0);
  operands[6] = x18;
  if (!scratch_operand (operands[6], E_SImode))
    return -1;
  x19 = XEXP (x8, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x8, 1);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  x21 = XEXP (x7, 1);
  if (!rtx_equal_p (x21, operands[2]))
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!rx_restricted_mem_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!rx_restricted_mem_operand (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern47 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!rx_shift_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x3, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 9; /* jump */
        }
      break;

    case REG:
    case SUBREG:
      if (register_operand (x2, E_SImode))
        {
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case PC:
              operands[0] = x2;
              return 10; /* indirect_jump */

            case ZERO_EXTRACT:
              if (pnum_clobbers != NULL
                  && pattern27 (x1) == 0)
                {
                  *pnum_clobbers = 1;
                  return 146; /* rx_insv_reg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case CONST_INT:
      operands[2] = x2;
      if (const_int_operand (operands[2], E_SImode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == ZERO_EXTRACT
              && GET_MODE (x3) == E_SImode)
            {
              x5 = XEXP (x3, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  x6 = XEXP (x3, 0);
                  operands[0] = x6;
                  if (register_operand (operands[0], E_SImode))
                    {
                      x7 = XEXP (x3, 2);
                      operands[1] = x7;
                      if (rx_shift_operand (operands[1], E_SImode))
                        return 145; /* *insv_imm */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 22; /* *movsf_internal */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      return 23; /* *movsi_internal */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      return 24; /* *movhi_internal */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode))
        return -1;
      return 25; /* *movqi_internal */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !
#line 2864 "../../gcc/config/rx/rx.md"
(TARGET_ENABLE_LRA))
        return -1;
      return 180; /* movdi */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 2873 "../../gcc/config/rx/rx.md"
(TARGET_ENABLE_LRA))
        return -1;
      return 181; /* movdf */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      return recog_7 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_6 (x1, insn, pnum_clobbers);

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!rx_call_operand (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 19; /* call_value_internal */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_5 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      switch (pattern0 (x1))
        {
        case 0:
          return 26; /* extendhisi2 */

        case 1:
          return 27; /* extendqisi2 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern0 (x1))
        {
        case 0:
          return 28; /* zero_extendhisi2 */

        case 1:
          return 29; /* zero_extendqisi2 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pnum_clobbers != NULL)
        {
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (comparison_operator (x2, E_SImode))
        {
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) == REG
              && REGNO (x3) == 16)
            {
              x4 = XEXP (x2, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x5 = XEXP (x1, 0);
                  switch (GET_CODE (x5))
                    {
                    case REG:
                    case SUBREG:
                      operands[0] = x5;
                      if (register_operand (operands[0], E_SImode))
                        {
                          operands[1] = x2;
                          if (
#line 705 "../../gcc/config/rx/rx.md"
(reload_completed))
                            return 35; /* *sccc */
                        }
                      break;

                    case ZERO_EXTRACT:
                      if (pattern27 (x1) == 0
                          && 
#line 2183 "../../gcc/config/rx/rx.md"
(reload_completed))
                        return 148; /* *bmcc */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      if (!rx_fp_comparison_operator (x2, E_SImode))
        return -1;
      operands[1] = x2;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!rx_source_operand (operands[3], E_SFmode)
          || !
#line 715 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
        return -1;
      return 36; /* cstoresf4 */

    case ABS:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 40; /* abssi2 */

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern12 (x2))
            {
            case 0:
              *pnum_clobbers = 1;
              return 42; /* addsi3_internal */

            case 1:
              if (!
#line 1947 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
                return -1;
              *pnum_clobbers = 1;
              return 133; /* addsf3 */

            case 2:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 89; /* plussi3_zero_extendhi */

            case 3:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 97; /* plussi3_zero_extendqi */

            case 4:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 93; /* plussi3_sign_extendhi */

            case 5:
              if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 101; /* plussi3_sign_extendqi */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != LTU
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 16
              || GET_MODE (x7) != E_CCmode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!rx_source_operand (operands[2], E_SImode)
              || !
#line 950 "../../gcc/config/rx/rx.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 44; /* adc_internal */

        default:
          return -1;
        }

    case AND:
      return recog_8 (x1, insn, pnum_clobbers);

    case BSWAP:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 49; /* bswapsi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 50; /* bswaphi2 */

        default:
          return -1;
        }

    case DIV:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern12 (x2))
        {
        case 0:
          *pnum_clobbers = 1;
          return 51; /* divsi3 */

        case 1:
          if (!
#line 1958 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
            return -1;
          *pnum_clobbers = 1;
          return 134; /* divsf3 */

        case 2:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 105; /* divsi3_zero_extendhi */

        case 3:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 111; /* divsi3_zero_extendqi */

        case 4:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 108; /* divsi3_sign_extendhi */

        case 5:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 114; /* divsi3_sign_extendqi */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern28 (x2))
        {
        case 0:
          *pnum_clobbers = 1;
          return 52; /* udivsi3 */

        case 1:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 106; /* udivsi3_zero_extendhi */

        case 2:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 112; /* udivsi3_zero_extendqi */

        case 3:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* udivsi3_sign_extendhi */

        case 4:
          if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 115; /* udivsi3_sign_extendqi */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          if (pattern13 (x2, 
SIGN_EXTEND) != 0
              || !rx_source_operand (operands[2], E_SImode)
              || !
#line 1208 "../../gcc/config/rx/rx.md"
(! TARGET_BIG_ENDIAN_DATA))
            return -1;
          return 53; /* mulsidi3 */

        case ZERO_EXTEND:
          if (pattern13 (x2, 
ZERO_EXTEND) != 0
              || !rx_compare_operand (operands[2], E_SImode)
              || !
#line 1222 "../../gcc/config/rx/rx.md"
(! TARGET_BIG_ENDIAN_DATA))
            return -1;
          return 54; /* umulsidi3 */

        case REG:
        case SUBREG:
          operands[1] = x3;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern10 (x2, 
E_SImode) != 0)
                    return -1;
                  return 63; /* mulsi3 */

                case E_SFmode:
                  if (pnum_clobbers == NULL
                      || pattern10 (x2, 
E_SFmode) != 0
                      || !
#line 1969 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
                    return -1;
                  *pnum_clobbers = 1;
                  return 135; /* mulsf3 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern11 (x2))
                {
                case 0:
                  if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 119; /* multsi3_zero_extendhi */

                case 1:
                  if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 125; /* multsi3_zero_extendqi */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern11 (x2))
                {
                case 0:
                  if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 122; /* multsi3_sign_extendhi */

                case 1:
                  if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 128; /* multsi3_sign_extendqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x4;
              if (!rx_source_operand (operands[2], E_SImode))
                return -1;
              return 55; /* smaxsi3 */

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x10 = XEXP (x4, 0);
              operands[2] = x10;
              if (rx_minmaxex_operand (operands[2], E_HImode))
                return 57; /* umaxhi3_u */
              if (rx_minmaxex_operand (operands[2], E_QImode))
                return 58; /* umaxqi3_u */
              if (rx_restricted_mem_operand (operands[2], E_HImode)
                  && 
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return 117; /* smaxsi3_zero_extendhi */
              if (!rx_restricted_mem_operand (operands[2], E_QImode)
                  || !
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 123; /* smaxsi3_zero_extendqi */

            case SIGN_EXTEND:
              switch (pattern2 (x4))
                {
                case 0:
                  if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 120; /* smaxsi3_sign_extendhi */

                case 1:
                  if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                    return -1;
                  return 126; /* smaxsi3_sign_extendqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if (rx_minmaxex_operand (operands[2], E_HImode))
            return 61; /* umaxhi3_ur */
          if (!rx_minmaxex_operand (operands[2], E_QImode))
            return -1;
          return 62; /* umaxqi3_ur */

        default:
          return -1;
        }

    case SMIN:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern28 (x2))
            {
            case 0:
              return 56; /* sminsi3 */

            case 1:
              if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 118; /* sminsi3_zero_extendhi */

            case 2:
              if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 124; /* sminsi3_zero_extendqi */

            case 3:
              if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 121; /* sminsi3_sign_extendhi */

            case 4:
              if (!
#line 1883 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              return 127; /* sminsi3_sign_extendqi */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if (rx_minmaxex_operand (operands[2], E_HImode))
            return 59; /* uminhi3_ur */
          if (!rx_minmaxex_operand (operands[2], E_QImode))
            return -1;
          return 60; /* uminqi3_ur */

        default:
          return -1;
        }

    case NEG:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 64; /* negsi2 */

    case NOT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 66; /* one_cmplsi2 */

    case IOR:
      switch (pattern4 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 68; /* iorsi3 */

        case 1:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 91; /* iorsi3_zero_extendhi */

        case 2:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 99; /* iorsi3_zero_extendqi */

        case 3:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 95; /* iorsi3_sign_extendhi */

        case 4:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 103; /* iorsi3_sign_extendqi */

        case 5:
          return 139; /* bitset */

        case 6:
          return 140; /* bitset_in_memory */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern5 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 70; /* rotlsi3 */

    case ROTATERT:
      if (pattern5 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 72; /* rotrsi3 */

    case ASHIFT:
      if (pattern5 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 78; /* ashlsi3 */

    case SS_PLUS:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!rx_source_operand (operands[2], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 80; /* ssaddsi3 */

    case UNSPEC:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 2:
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          switch (XINT (x2, 1))
            {
            case 49:
              x12 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 16
                  || GET_MODE (x12) != E_CCmode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 1612 "../../gcc/config/rx/rx.md"
(reload_completed))
                return -1;
              return 81; /* *sat */

            case 40:
              if (!immediate_operand (operands[1], E_SImode))
                return -1;
              x12 = XVECEXP (x2, 0, 1);
              operands[2] = x12;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 178; /* mvfcp */

            default:
              return -1;
            }

        case 1:
          switch (XINT (x2, 1))
            {
            case 37:
              x11 = XVECEXP (x2, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 162; /* mvfachi */

            case 38:
              x11 = XVECEXP (x2, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 163; /* mvfacmi */

            case 46:
              x11 = XVECEXP (x2, 0, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 168; /* revw */

            case 48:
              if (pnum_clobbers == NULL)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              operands[1] = x11;
              if (!rx_compare_operand (operands[1], E_SFmode))
                return -1;
              *pnum_clobbers = 1;
              return 169; /* lrintsf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern12 (x2))
            {
            case 0:
              *pnum_clobbers = 1;
              return 82; /* subsi3 */

            case 1:
              if (!
#line 1980 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
                return -1;
              *pnum_clobbers = 1;
              return 136; /* subsf3 */

            case 2:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 107; /* minussi3_zero_extendhi */

            case 3:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 113; /* minussi3_zero_extendqi */

            case 4:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 110; /* minussi3_sign_extendhi */

            case 5:
              if (!
#line 1873 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
                return -1;
              *pnum_clobbers = 1;
              return 116; /* minussi3_sign_extendqi */

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != GEU
              || GET_MODE (x4) != E_SImode)
            return -1;
          x10 = XEXP (x4, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 16
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x13 = XEXP (x4, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!rx_compare_operand (operands[2], E_SImode)
              || !
#line 1672 "../../gcc/config/rx/rx.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 84; /* sbb_internal */

        default:
          return -1;
        }

    case XOR:
      switch (pattern4 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 87; /* xorsi3 */

        case 1:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 92; /* xorsi3_zero_extendhi */

        case 2:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 100; /* xorsi3_zero_extendqi */

        case 3:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 96; /* xorsi3_sign_extendhi */

        case 4:
          if (!
#line 1862 "../../gcc/config/rx/rx.md"
((optimize < 3 || optimize_size)))
            return -1;
          *pnum_clobbers = 1;
          return 104; /* xorsi3_sign_extendqi */

        case 5:
          return 141; /* bitinvert */

        case 6:
          return 142; /* bitinvert_in_memory */

        default:
          return -1;
        }

    case FIX:
      if (pattern6 (x1, pnum_clobbers, 
E_SFmode, 
E_SImode) != 0
          || !
#line 1990 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
        return -1;
      *pnum_clobbers = 1;
      return 137; /* fix_truncsfsi2 */

    case FLOAT:
      if (pattern6 (x1, pnum_clobbers, 
E_SImode, 
E_SFmode) != 0
          || !
#line 2000 "../../gcc/config/rx/rx.md"
(ALLOW_RX_FPU_INSNS))
        return -1;
      *pnum_clobbers = 1;
      return 138; /* floatsisf2 */

    case ASHIFTRT:
    case LSHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (register_operand (operands[1], E_SImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (rx_shift_operand (operands[2], E_SImode))
                {
                  switch (GET_CODE (x2))
                    {
                    case ASHIFTRT:
                      *pnum_clobbers = 1;
                      return 74; /* ashrsi3 */

                    case LSHIFTRT:
                      *pnum_clobbers = 1;
                      return 76; /* lshrsi3 */

                    default:
                      break;
                    }
                }
            }
        }
      operands[3] = x2;
      if (!rshift_operator (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || GET_CODE (x5) != ZERO_EXTRACT
          || pattern31 (x5) != 0)
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 149; /* *insv_cond_lt */

    case UNSPEC_VOLATILE:
      return recog_4 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
